Index: /branches/HeuristicLab.Services.Authentication Prototype/Service/Provider/HeuristicLabMembershipProvider.cs
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Service/Provider/HeuristicLabMembershipProvider.cs	(revision 4018)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Service/Provider/HeuristicLabMembershipProvider.cs	(revision 4019)
@@ -269,4 +269,14 @@
     }
 
+
+    /// <summary>
+    /// delete a specified user from the membership data
+    /// </summary>
+    /// <param name="username"></param>
+    /// <param name="deleteAllRelatedData"></param>
+    /// <returns>
+    /// return a true if was possible to delete the user
+    /// return false if the db connection not exist or a exception occour
+    /// </returns>
     public override bool DeleteUser(string username, bool deleteAllRelatedData) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -374,4 +384,15 @@
     }
 
+
+    /// <summary>
+    /// return the right password of the user
+    /// the user has do give the right answer to a question
+    /// to get his password information
+    /// </summary>
+    /// <param name="username"></param>
+    /// <param name="answer"></param>
+    /// <returns>
+    /// return a string type of the right password
+    /// </returns>
     public override string GetPassword(string username, string answer) {
       if (PasswordFormat == MembershipPasswordFormat.Hashed)
@@ -390,4 +411,12 @@
     }
 
+    /// <summary>
+    /// get a user of the type of the Membershipuser
+    /// </summary>
+    /// <param name="username"></param>
+    /// <param name="userisOnline"></param>
+    /// <returns>
+    /// returns the searched membershipuser
+    /// </returns>
     public override MembershipUser GetUser(string username, bool userIsOnline) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -401,4 +430,14 @@
     }
 
+
+    /// <summary>
+    /// search a user over the providerUserKey and return
+    /// the right membershipuser
+    /// </summary>
+    /// <param name="providerUserKey"></param>
+    /// <param name="userIsOnline"></param>
+    /// <returns>
+    /// return the right membershipuser
+    /// </returns>
     public override MembershipUser GetUser(object providerUserKey, bool userIsOnline) {
       long ID = providerUserKey is long ? (long)providerUserKey : -1;
@@ -413,4 +452,11 @@
     }
 
+    /// <summary>
+    /// search over the email the right username
+    /// </summary>
+    /// <param name="email"></param>
+    /// <returns>
+    /// return a string with the username
+    /// </returns>
     public override string GetUserNameByEmail(string email) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -427,8 +473,26 @@
     }
 
+    /// <summary>
+    /// after the question user have to give the right answer
+    /// then here will the password reseted
+    /// </summary>
+    /// <param name="username"></param>
+    /// <param name="answer"></param>
+    /// <returns>
+    /// return new password
+    /// </returns>
     public override string ResetPassword(string username, string answer) {
       throw new NotSupportedException("Restet password not avaliable");
     }
 
+
+    /// <summary>
+    /// Lock a specified user over the username
+    /// </summary>
+    /// <param name="username"></param>
+    /// <returns>
+    /// return true if was possible and
+    /// flase if there was a exception
+    /// </returns>
     public bool LockUser(string userName) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -453,4 +517,13 @@
     }
 
+
+    /// <summary>
+    /// unlock specified user over the username
+    /// </summary>
+    /// <param name="username"></param>
+    /// <returns>
+    /// return true if was possible and
+    /// false if not
+    /// </returns>
     public override bool UnlockUser(string userName) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -475,4 +548,11 @@
     }
 
+
+    /// <summary>
+    /// Update existend user
+    /// </summary>
+    /// <param name="user"></param>
+    /// <returns>
+    /// </returns>
     public override void UpdateUser(MembershipUser user) {
       using (DataClassesDataContext db = DatabaseUtil.createDataClassesDataContext()) {
@@ -584,4 +664,11 @@
     private readonly byte[] _rgbIv = new byte[] { 60, 121, 178, 142, 50, 160, 226, 84, 41, 66, 158, 180, 26, 232, 42, 113 };
 
+    /// <summary>
+    /// encrypt passwort 
+    /// </summary>
+    /// <param name="password"></param>
+    /// <returns>
+    /// return encrypted password
+    /// </returns>
     protected override byte[] EncryptPassword(byte[] password) {
       SymmetricAlgorithm sa = Aes.Create();
@@ -594,5 +681,11 @@
       return encryptedTextBytes;
     }
-
+    /// <summary>
+    /// decrypt passwort 
+    /// </summary>
+    /// <param name="password"></param>
+    /// <returns>
+    /// return decrypted password
+    /// </returns>
     protected override byte[] DecryptPassword(byte[] encodedPassword) {
       SymmetricAlgorithm sa = Aes.Create();