Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/LaggedVariable.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/LaggedVariable.cs	(revision 3993)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/LaggedVariable.cs	(revision 4022)
@@ -34,46 +34,46 @@
   [StorableClass]
   [Item("LaggedVariable", "Represents a variable value with a time offset.")]
-  public sealed class LaggedVariable : Symbol {
-    #region Properties
-    [Storable]
-    private double weightNu;
-    public double WeightNu {
-      get { return weightNu; }
-      set { weightNu = value; }
-    }
-    [Storable]
-    private double weightSigma;
-    public double WeightSigma {
-      get { return weightSigma; }
-      set {
-        if (weightSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
-        weightSigma = value;
-      }
-    }
-    [Storable]
-    private double weightManipulatorNu;
-    public double WeightManipulatorNu {
-      get { return weightManipulatorNu; }
-      set { weightManipulatorNu = value; }
-    }
-    [Storable]
-    private double weightManipulatorSigma;
-    public double WeightManipulatorSigma {
-      get { return weightManipulatorSigma; }
-      set {
-        if (weightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
-        weightManipulatorSigma = value;
-      }
-    }
-    private List<string> variableNames;
-    [Storable]
-    public IEnumerable<string> VariableNames {
-      get { return variableNames; }
-      set {
-        if (value == null) throw new ArgumentNullException();
-        variableNames.Clear();
-        variableNames.AddRange(value);
-      }
-    }
+  public sealed class LaggedVariable : Variable {
+    //#region Properties
+    //[Storable]
+    //private double weightNu;
+    //public double WeightNu {
+    //  get { return weightNu; }
+    //  set { weightNu = value; }
+    //}
+    //[Storable]
+    //private double weightSigma;
+    //public double WeightSigma {
+    //  get { return weightSigma; }
+    //  set {
+    //    if (weightSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
+    //    weightSigma = value;
+    //  }
+    //}
+    //[Storable]
+    //private double weightManipulatorNu;
+    //public double WeightManipulatorNu {
+    //  get { return weightManipulatorNu; }
+    //  set { weightManipulatorNu = value; }
+    //}
+    //[Storable]
+    //private double weightManipulatorSigma;
+    //public double WeightManipulatorSigma {
+    //  get { return weightManipulatorSigma; }
+    //  set {
+    //    if (weightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
+    //    weightManipulatorSigma = value;
+    //  }
+    //}
+    //private List<string> variableNames;
+    //[Storable]
+    //public IEnumerable<string> VariableNames {
+    //  get { return variableNames; }
+    //  set {
+    //    if (value == null) throw new ArgumentNullException();
+    //    variableNames.Clear();
+    //    variableNames.AddRange(value);
+    //  }
+    //}
     [Storable]
     private int minLag;
@@ -88,13 +88,13 @@
       set { maxLag = value; }
     }
-    #endregion
+    //#endregion
     public LaggedVariable()
       : base("LaggedVariable", "Represents a variable value with a time offset.") {
-      weightNu = 1.0;
-      weightSigma = 1.0;
-      weightManipulatorNu = 0.0;
-      weightManipulatorSigma = 1.0;
-      variableNames = new List<string>();
-      minLag = 0; maxLag = 0;
+      //weightNu = 1.0;
+      //weightSigma = 1.0;
+      //weightManipulatorNu = 0.0;
+      //weightManipulatorSigma = 1.0;
+      //variableNames = new List<string>();
+      minLag = -1; maxLag = -1;
     }
 
@@ -105,9 +105,9 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       LaggedVariable clone = (LaggedVariable)base.Clone(cloner);
-      clone.weightNu = weightNu;
-      clone.weightSigma = weightSigma;
-      clone.variableNames = new List<string>(variableNames);
-      clone.weightManipulatorNu = weightManipulatorNu;
-      clone.weightManipulatorSigma = weightManipulatorSigma;
+      //clone.weightNu = weightNu;
+      //clone.weightSigma = weightSigma;
+      //clone.variableNames = new List<string>(variableNames);
+      //clone.weightManipulatorNu = weightManipulatorNu;
+      //clone.weightManipulatorSigma = weightManipulatorSigma;
       clone.minLag = minLag;
       clone.maxLag = maxLag;