Index: branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.Designer.cs	(revision 4042)
@@ -67,9 +67,28 @@
       this.tpJobControl = new System.Windows.Forms.TabPage();
       this.scJobControl = new System.Windows.Forms.SplitContainer();
-      this.lvJobControl = new System.Windows.Forms.ListView();
+      this.calculatingJobTabControl = new System.Windows.Forms.TabControl();
+      this.calculatingJobTabPage = new System.Windows.Forms.TabPage();
+      this.splitContainer5 = new System.Windows.Forms.SplitContainer();
+      this.cmb_calculatingJob_count = new System.Windows.Forms.ComboBox();
+      this.btn_calculatingJobs_next = new System.Windows.Forms.Button();
+      this.btn_calculatingJobs_prev = new System.Windows.Forms.Button();
+      this.lv_calculatingJobs = new System.Windows.Forms.ListView();
       this.contextMenuJob = new System.Windows.Forms.ContextMenuStrip(this.components);
-      this.menuItemAbortJob = new System.Windows.Forms.ToolStripMenuItem();
+      this.offlineItemAbortJob = new System.Windows.Forms.ToolStripMenuItem();
       this.menuItemGetSnapshot = new System.Windows.Forms.ToolStripMenuItem();
       this.ilSmallImgJob = new System.Windows.Forms.ImageList(this.components);
+      this.finishedJobsTabPage = new System.Windows.Forms.TabPage();
+      this.splitContainer2 = new System.Windows.Forms.SplitContainer();
+      this.cmb_finishedJob_count = new System.Windows.Forms.ComboBox();
+      this.btn_finishedJob_next = new System.Windows.Forms.Button();
+      this.btn_finishedJob_prev = new System.Windows.Forms.Button();
+      this.lv_finishedJobs = new System.Windows.Forms.ListView();
+      this.offlineJobsTabPage = new System.Windows.Forms.TabPage();
+      this.splitContainer4 = new System.Windows.Forms.SplitContainer();
+      this.cmb_offlineJob_count = new System.Windows.Forms.ComboBox();
+      this.btn_offlineJob_next = new System.Windows.Forms.Button();
+      this.btn_offlinejob_prev = new System.Windows.Forms.Button();
+      this.lv_offlineJobs = new System.Windows.Forms.ListView();
+      this.AbortContextMenuStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
       this.ilSmallImgClient = new System.Windows.Forms.ImageList(this.components);
       this.tpClientControl = new System.Windows.Forms.TabPage();
@@ -85,4 +104,11 @@
       this.tcManagementConsole = new System.Windows.Forms.TabControl();
       this.checkBox1 = new System.Windows.Forms.CheckBox();
+      this.splitContainer3 = new System.Windows.Forms.SplitContainer();
+      this.comboBox1 = new System.Windows.Forms.ComboBox();
+      this.button1 = new System.Windows.Forms.Button();
+      this.button2 = new System.Windows.Forms.Button();
+      this.listView1 = new System.Windows.Forms.ListView();
+      this.toolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
+      this.calcToolStripAbortItem = new System.Windows.Forms.ToolStripMenuItem();
       this.menuStrip1.SuspendLayout();
       this.plClientDetails.SuspendLayout();
@@ -97,5 +123,19 @@
       this.scJobControl.Panel2.SuspendLayout();
       this.scJobControl.SuspendLayout();
+      this.calculatingJobTabControl.SuspendLayout();
+      this.calculatingJobTabPage.SuspendLayout();
+      this.splitContainer5.Panel1.SuspendLayout();
+      this.splitContainer5.Panel2.SuspendLayout();
+      this.splitContainer5.SuspendLayout();
       this.contextMenuJob.SuspendLayout();
+      this.finishedJobsTabPage.SuspendLayout();
+      this.splitContainer2.Panel1.SuspendLayout();
+      this.splitContainer2.Panel2.SuspendLayout();
+      this.splitContainer2.SuspendLayout();
+      this.offlineJobsTabPage.SuspendLayout();
+      this.splitContainer4.Panel1.SuspendLayout();
+      this.splitContainer4.Panel2.SuspendLayout();
+      this.splitContainer4.SuspendLayout();
+      this.AbortContextMenuStrip.SuspendLayout();
       this.tpClientControl.SuspendLayout();
       this.scClientControl.Panel1.SuspendLayout();
@@ -107,4 +147,7 @@
       this.contextMenuGroup.SuspendLayout();
       this.tcManagementConsole.SuspendLayout();
+      this.splitContainer3.Panel1.SuspendLayout();
+      this.splitContainer3.Panel2.SuspendLayout();
+      this.splitContainer3.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -480,5 +523,5 @@
       // scJobControl.Panel1
       // 
-      this.scJobControl.Panel1.Controls.Add(this.lvJobControl);
+      this.scJobControl.Panel1.Controls.Add(this.calculatingJobTabControl);
       // 
       // scJobControl.Panel2
@@ -489,34 +532,107 @@
       this.scJobControl.TabIndex = 0;
       // 
-      // lvJobControl
-      // 
-      this.lvJobControl.AllowDrop = true;
-      this.lvJobControl.ContextMenuStrip = this.contextMenuJob;
-      this.lvJobControl.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lvJobControl.LargeImageList = this.ilLargeImgJob;
-      this.lvJobControl.Location = new System.Drawing.Point(0, 0);
-      this.lvJobControl.MultiSelect = false;
-      this.lvJobControl.Name = "lvJobControl";
-      this.lvJobControl.Size = new System.Drawing.Size(454, 386);
-      this.lvJobControl.SmallImageList = this.ilSmallImgJob;
-      this.lvJobControl.TabIndex = 0;
-      this.lvJobControl.UseCompatibleStateImageBehavior = false;
-      this.lvJobControl.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvJobControl_MouseUp);
-      this.lvJobControl.MouseMove += new System.Windows.Forms.MouseEventHandler(this.lvJobControl_MouseMove);
-      this.lvJobControl.Click += new System.EventHandler(this.OnLVJobControlClicked);
+      // calculatingJobTabControl
+      // 
+      this.calculatingJobTabControl.Controls.Add(this.calculatingJobTabPage);
+      this.calculatingJobTabControl.Controls.Add(this.finishedJobsTabPage);
+      this.calculatingJobTabControl.Controls.Add(this.offlineJobsTabPage);
+      this.calculatingJobTabControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.calculatingJobTabControl.Location = new System.Drawing.Point(0, 0);
+      this.calculatingJobTabControl.Name = "calculatingJobTabControl";
+      this.calculatingJobTabControl.SelectedIndex = 0;
+      this.calculatingJobTabControl.Size = new System.Drawing.Size(454, 386);
+      this.calculatingJobTabControl.TabIndex = 0;
+      // 
+      // calculatingJobTabPage
+      // 
+      this.calculatingJobTabPage.Controls.Add(this.splitContainer5);
+      this.calculatingJobTabPage.Location = new System.Drawing.Point(4, 22);
+      this.calculatingJobTabPage.Name = "calculatingJobTabPage";
+      this.calculatingJobTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.calculatingJobTabPage.Size = new System.Drawing.Size(446, 360);
+      this.calculatingJobTabPage.TabIndex = 2;
+      this.calculatingJobTabPage.Text = "Calculating Jobs";
+      this.calculatingJobTabPage.UseVisualStyleBackColor = true;
+      // 
+      // splitContainer5
+      // 
+      this.splitContainer5.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer5.Location = new System.Drawing.Point(3, 3);
+      this.splitContainer5.Name = "splitContainer5";
+      this.splitContainer5.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer5.Panel1
+      // 
+      this.splitContainer5.Panel1.Controls.Add(this.cmb_calculatingJob_count);
+      this.splitContainer5.Panel1.Controls.Add(this.btn_calculatingJobs_next);
+      this.splitContainer5.Panel1.Controls.Add(this.btn_calculatingJobs_prev);
+      // 
+      // splitContainer5.Panel2
+      // 
+      this.splitContainer5.Panel2.Controls.Add(this.lv_calculatingJobs);
+      this.splitContainer5.Size = new System.Drawing.Size(440, 354);
+      this.splitContainer5.SplitterDistance = 28;
+      this.splitContainer5.TabIndex = 3;
+      // 
+      // cmb_calculatingJob_count
+      // 
+      this.cmb_calculatingJob_count.FormattingEnabled = true;
+      this.cmb_calculatingJob_count.Items.AddRange(new object[] {
+            "25",
+            "50",
+            "75",
+            "100"});
+      this.cmb_calculatingJob_count.Location = new System.Drawing.Point(165, 3);
+      this.cmb_calculatingJob_count.Name = "cmb_calculatingJob_count";
+      this.cmb_calculatingJob_count.Size = new System.Drawing.Size(48, 21);
+      this.cmb_calculatingJob_count.TabIndex = 2;
+      this.cmb_calculatingJob_count.SelectedIndexChanged += new System.EventHandler(this.cmb_count_SelectedIndexChanged);
+      // 
+      // btn_calculatingJobs_next
+      // 
+      this.btn_calculatingJobs_next.Location = new System.Drawing.Point(84, 3);
+      this.btn_calculatingJobs_next.Name = "btn_calculatingJobs_next";
+      this.btn_calculatingJobs_next.Size = new System.Drawing.Size(75, 23);
+      this.btn_calculatingJobs_next.TabIndex = 1;
+      this.btn_calculatingJobs_next.Text = "-->";
+      this.btn_calculatingJobs_next.UseVisualStyleBackColor = true;
+      this.btn_calculatingJobs_next.Click += new System.EventHandler(this.btn_next_Click);
+      // 
+      // btn_calculatingJobs_prev
+      // 
+      this.btn_calculatingJobs_prev.Location = new System.Drawing.Point(3, 3);
+      this.btn_calculatingJobs_prev.Name = "btn_calculatingJobs_prev";
+      this.btn_calculatingJobs_prev.Size = new System.Drawing.Size(75, 23);
+      this.btn_calculatingJobs_prev.TabIndex = 0;
+      this.btn_calculatingJobs_prev.Text = "<--";
+      this.btn_calculatingJobs_prev.UseVisualStyleBackColor = true;
+      this.btn_calculatingJobs_prev.Click += new System.EventHandler(this.btn_prev_Click);
+      // 
+      // lv_calculatingJobs
+      // 
+      this.lv_calculatingJobs.ContextMenuStrip = this.contextMenuJob;
+      this.lv_calculatingJobs.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.lv_calculatingJobs.LargeImageList = this.ilLargeImgJob;
+      this.lv_calculatingJobs.Location = new System.Drawing.Point(0, 0);
+      this.lv_calculatingJobs.Name = "lv_calculatingJobs";
+      this.lv_calculatingJobs.Size = new System.Drawing.Size(440, 322);
+      this.lv_calculatingJobs.SmallImageList = this.ilSmallImgJob;
+      this.lv_calculatingJobs.TabIndex = 0;
+      this.lv_calculatingJobs.UseCompatibleStateImageBehavior = false;
+      this.lv_calculatingJobs.SelectedIndexChanged += new System.EventHandler(this.lv_Jobs_SelectedIndexChanged);
       // 
       // contextMenuJob
       // 
       this.contextMenuJob.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.menuItemAbortJob,
-            this.menuItemGetSnapshot});
+            this.menuItemGetSnapshot,
+            this.calcToolStripAbortItem});
       this.contextMenuJob.Name = "contextMenuJob";
       this.contextMenuJob.Size = new System.Drawing.Size(145, 48);
       // 
-      // menuItemAbortJob
-      // 
-      this.menuItemAbortJob.Name = "menuItemAbortJob";
-      this.menuItemAbortJob.Size = new System.Drawing.Size(144, 22);
-      this.menuItemAbortJob.Text = "Abort";
+      // offlineItemAbortJob
+      // 
+      this.offlineItemAbortJob.Name = "offlineItemAbortJob";
+      this.offlineItemAbortJob.Size = new System.Drawing.Size(152, 22);
+      this.offlineItemAbortJob.Text = "Abort";
       // 
       // menuItemGetSnapshot
@@ -533,4 +649,166 @@
       this.ilSmallImgJob.Images.SetKeyName(1, "Forward.png");
       this.ilSmallImgJob.Images.SetKeyName(2, "pause.png");
+      // 
+      // finishedJobsTabPage
+      // 
+      this.finishedJobsTabPage.Controls.Add(this.splitContainer2);
+      this.finishedJobsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.finishedJobsTabPage.Name = "finishedJobsTabPage";
+      this.finishedJobsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.finishedJobsTabPage.Size = new System.Drawing.Size(446, 360);
+      this.finishedJobsTabPage.TabIndex = 0;
+      this.finishedJobsTabPage.Text = "Finished Jobs";
+      this.finishedJobsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // splitContainer2
+      // 
+      this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer2.Location = new System.Drawing.Point(3, 3);
+      this.splitContainer2.Name = "splitContainer2";
+      this.splitContainer2.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer2.Panel1
+      // 
+      this.splitContainer2.Panel1.Controls.Add(this.cmb_finishedJob_count);
+      this.splitContainer2.Panel1.Controls.Add(this.btn_finishedJob_next);
+      this.splitContainer2.Panel1.Controls.Add(this.btn_finishedJob_prev);
+      // 
+      // splitContainer2.Panel2
+      // 
+      this.splitContainer2.Panel2.Controls.Add(this.lv_finishedJobs);
+      this.splitContainer2.Size = new System.Drawing.Size(440, 354);
+      this.splitContainer2.SplitterDistance = 28;
+      this.splitContainer2.TabIndex = 2;
+      // 
+      // cmb_finishedJob_count
+      // 
+      this.cmb_finishedJob_count.FormattingEnabled = true;
+      this.cmb_finishedJob_count.Items.AddRange(new object[] {
+            "25",
+            "50",
+            "75",
+            "100"});
+      this.cmb_finishedJob_count.Location = new System.Drawing.Point(165, 3);
+      this.cmb_finishedJob_count.Name = "cmb_finishedJob_count";
+      this.cmb_finishedJob_count.Size = new System.Drawing.Size(48, 21);
+      this.cmb_finishedJob_count.TabIndex = 2;
+      this.cmb_finishedJob_count.SelectedIndexChanged += new System.EventHandler(this.cmb_count_SelectedIndexChanged);
+      // 
+      // btn_finishedJob_next
+      // 
+      this.btn_finishedJob_next.Location = new System.Drawing.Point(84, 3);
+      this.btn_finishedJob_next.Name = "btn_finishedJob_next";
+      this.btn_finishedJob_next.Size = new System.Drawing.Size(75, 23);
+      this.btn_finishedJob_next.TabIndex = 1;
+      this.btn_finishedJob_next.Text = "-->";
+      this.btn_finishedJob_next.UseVisualStyleBackColor = true;
+      this.btn_finishedJob_next.Click += new System.EventHandler(this.btn_next_Click);
+      // 
+      // btn_finishedJob_prev
+      // 
+      this.btn_finishedJob_prev.Location = new System.Drawing.Point(3, 3);
+      this.btn_finishedJob_prev.Name = "btn_finishedJob_prev";
+      this.btn_finishedJob_prev.Size = new System.Drawing.Size(75, 23);
+      this.btn_finishedJob_prev.TabIndex = 0;
+      this.btn_finishedJob_prev.Text = "<--";
+      this.btn_finishedJob_prev.UseVisualStyleBackColor = true;
+      this.btn_finishedJob_prev.Click += new System.EventHandler(this.btn_prev_Click);
+      // 
+      // lv_finishedJobs
+      // 
+      this.lv_finishedJobs.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.lv_finishedJobs.LargeImageList = this.ilLargeImgJob;
+      this.lv_finishedJobs.Location = new System.Drawing.Point(0, 0);
+      this.lv_finishedJobs.Name = "lv_finishedJobs";
+      this.lv_finishedJobs.Size = new System.Drawing.Size(440, 322);
+      this.lv_finishedJobs.SmallImageList = this.ilSmallImgJob;
+      this.lv_finishedJobs.TabIndex = 0;
+      this.lv_finishedJobs.UseCompatibleStateImageBehavior = false;
+      this.lv_finishedJobs.SelectedIndexChanged += new System.EventHandler(this.lv_Jobs_SelectedIndexChanged);
+      // 
+      // offlineJobsTabPage
+      // 
+      this.offlineJobsTabPage.Controls.Add(this.splitContainer4);
+      this.offlineJobsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.offlineJobsTabPage.Name = "offlineJobsTabPage";
+      this.offlineJobsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.offlineJobsTabPage.Size = new System.Drawing.Size(446, 360);
+      this.offlineJobsTabPage.TabIndex = 1;
+      this.offlineJobsTabPage.Text = "Offline Jobs";
+      this.offlineJobsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // splitContainer4
+      // 
+      this.splitContainer4.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer4.Location = new System.Drawing.Point(3, 3);
+      this.splitContainer4.Name = "splitContainer4";
+      this.splitContainer4.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer4.Panel1
+      // 
+      this.splitContainer4.Panel1.Controls.Add(this.cmb_offlineJob_count);
+      this.splitContainer4.Panel1.Controls.Add(this.btn_offlineJob_next);
+      this.splitContainer4.Panel1.Controls.Add(this.btn_offlinejob_prev);
+      // 
+      // splitContainer4.Panel2
+      // 
+      this.splitContainer4.Panel2.Controls.Add(this.lv_offlineJobs);
+      this.splitContainer4.Size = new System.Drawing.Size(440, 354);
+      this.splitContainer4.SplitterDistance = 28;
+      this.splitContainer4.TabIndex = 3;
+      // 
+      // cmb_offlineJob_count
+      // 
+      this.cmb_offlineJob_count.FormattingEnabled = true;
+      this.cmb_offlineJob_count.Items.AddRange(new object[] {
+            "25",
+            "50",
+            "75",
+            "100"});
+      this.cmb_offlineJob_count.Location = new System.Drawing.Point(165, 3);
+      this.cmb_offlineJob_count.Name = "cmb_offlineJob_count";
+      this.cmb_offlineJob_count.Size = new System.Drawing.Size(48, 21);
+      this.cmb_offlineJob_count.TabIndex = 2;
+      this.cmb_offlineJob_count.SelectedIndexChanged += new System.EventHandler(this.cmb_count_SelectedIndexChanged);
+      // 
+      // btn_offlineJob_next
+      // 
+      this.btn_offlineJob_next.Location = new System.Drawing.Point(84, 3);
+      this.btn_offlineJob_next.Name = "btn_offlineJob_next";
+      this.btn_offlineJob_next.Size = new System.Drawing.Size(75, 23);
+      this.btn_offlineJob_next.TabIndex = 1;
+      this.btn_offlineJob_next.Text = "-->";
+      this.btn_offlineJob_next.UseVisualStyleBackColor = true;
+      this.btn_offlineJob_next.Click += new System.EventHandler(this.btn_next_Click);
+      // 
+      // btn_offlinejob_prev
+      // 
+      this.btn_offlinejob_prev.Location = new System.Drawing.Point(3, 3);
+      this.btn_offlinejob_prev.Name = "btn_offlinejob_prev";
+      this.btn_offlinejob_prev.Size = new System.Drawing.Size(75, 23);
+      this.btn_offlinejob_prev.TabIndex = 0;
+      this.btn_offlinejob_prev.Text = "<--";
+      this.btn_offlinejob_prev.UseVisualStyleBackColor = true;
+      this.btn_offlinejob_prev.Click += new System.EventHandler(this.btn_prev_Click);
+      // 
+      // lv_offlineJobs
+      // 
+      this.lv_offlineJobs.ContextMenuStrip = this.AbortContextMenuStrip;
+      this.lv_offlineJobs.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.lv_offlineJobs.LargeImageList = this.ilLargeImgJob;
+      this.lv_offlineJobs.Location = new System.Drawing.Point(0, 0);
+      this.lv_offlineJobs.Name = "lv_offlineJobs";
+      this.lv_offlineJobs.Size = new System.Drawing.Size(440, 322);
+      this.lv_offlineJobs.SmallImageList = this.ilSmallImgJob;
+      this.lv_offlineJobs.TabIndex = 0;
+      this.lv_offlineJobs.UseCompatibleStateImageBehavior = false;
+      this.lv_offlineJobs.SelectedIndexChanged += new System.EventHandler(this.lv_Jobs_SelectedIndexChanged);
+      // 
+      // AbortContextMenuStrip
+      // 
+      this.AbortContextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.offlineItemAbortJob});
+      this.AbortContextMenuStrip.Name = "AbortContextMenuStrip";
+      this.AbortContextMenuStrip.Size = new System.Drawing.Size(105, 26);
       // 
       // ilSmallImgClient
@@ -675,4 +953,78 @@
       this.checkBox1.Text = "checkBox1";
       this.checkBox1.UseVisualStyleBackColor = true;
+      // 
+      // splitContainer3
+      // 
+      this.splitContainer3.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer3.Location = new System.Drawing.Point(3, 3);
+      this.splitContainer3.Name = "splitContainer3";
+      this.splitContainer3.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer3.Panel1
+      // 
+      this.splitContainer3.Panel1.Controls.Add(this.comboBox1);
+      this.splitContainer3.Panel1.Controls.Add(this.button1);
+      this.splitContainer3.Panel1.Controls.Add(this.button2);
+      // 
+      // splitContainer3.Panel2
+      // 
+      this.splitContainer3.Panel2.Controls.Add(this.listView1);
+      this.splitContainer3.Size = new System.Drawing.Size(440, 354);
+      this.splitContainer3.SplitterDistance = 28;
+      this.splitContainer3.TabIndex = 2;
+      // 
+      // comboBox1
+      // 
+      this.comboBox1.FormattingEnabled = true;
+      this.comboBox1.Items.AddRange(new object[] {
+            "25",
+            "50",
+            "75",
+            "100"});
+      this.comboBox1.Location = new System.Drawing.Point(165, 3);
+      this.comboBox1.Name = "comboBox1";
+      this.comboBox1.Size = new System.Drawing.Size(48, 21);
+      this.comboBox1.TabIndex = 2;
+      // 
+      // button1
+      // 
+      this.button1.Location = new System.Drawing.Point(84, 3);
+      this.button1.Name = "button1";
+      this.button1.Size = new System.Drawing.Size(75, 23);
+      this.button1.TabIndex = 1;
+      this.button1.Text = "-->";
+      this.button1.UseVisualStyleBackColor = true;
+      // 
+      // button2
+      // 
+      this.button2.Location = new System.Drawing.Point(3, 3);
+      this.button2.Name = "button2";
+      this.button2.Size = new System.Drawing.Size(75, 23);
+      this.button2.TabIndex = 0;
+      this.button2.Text = "<--";
+      this.button2.UseVisualStyleBackColor = true;
+      // 
+      // listView1
+      // 
+      this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.listView1.LargeImageList = this.ilLargeImgJob;
+      this.listView1.Location = new System.Drawing.Point(0, 0);
+      this.listView1.Name = "listView1";
+      this.listView1.Size = new System.Drawing.Size(440, 322);
+      this.listView1.SmallImageList = this.ilSmallImgJob;
+      this.listView1.TabIndex = 0;
+      this.listView1.UseCompatibleStateImageBehavior = false;
+      // 
+      // toolStripMenuItem1
+      // 
+      this.toolStripMenuItem1.Name = "toolStripMenuItem1";
+      this.toolStripMenuItem1.Size = new System.Drawing.Size(152, 22);
+      this.toolStripMenuItem1.Text = "Abort";
+      // 
+      // calcToolStripAbortItem
+      // 
+      this.calcToolStripAbortItem.Name = "calcToolStripAbortItem";
+      this.calcToolStripAbortItem.Size = new System.Drawing.Size(144, 22);
+      this.calcToolStripAbortItem.Text = "Abort";
       // 
       // HiveServerManagementConsole
@@ -703,5 +1055,19 @@
       this.scJobControl.Panel2.ResumeLayout(false);
       this.scJobControl.ResumeLayout(false);
+      this.calculatingJobTabControl.ResumeLayout(false);
+      this.calculatingJobTabPage.ResumeLayout(false);
+      this.splitContainer5.Panel1.ResumeLayout(false);
+      this.splitContainer5.Panel2.ResumeLayout(false);
+      this.splitContainer5.ResumeLayout(false);
       this.contextMenuJob.ResumeLayout(false);
+      this.finishedJobsTabPage.ResumeLayout(false);
+      this.splitContainer2.Panel1.ResumeLayout(false);
+      this.splitContainer2.Panel2.ResumeLayout(false);
+      this.splitContainer2.ResumeLayout(false);
+      this.offlineJobsTabPage.ResumeLayout(false);
+      this.splitContainer4.Panel1.ResumeLayout(false);
+      this.splitContainer4.Panel2.ResumeLayout(false);
+      this.splitContainer4.ResumeLayout(false);
+      this.AbortContextMenuStrip.ResumeLayout(false);
       this.tpClientControl.ResumeLayout(false);
       this.scClientControl.Panel1.ResumeLayout(false);
@@ -713,4 +1079,7 @@
       this.contextMenuGroup.ResumeLayout(false);
       this.tcManagementConsole.ResumeLayout(false);
+      this.splitContainer3.Panel1.ResumeLayout(false);
+      this.splitContainer3.Panel2.ResumeLayout(false);
+      this.splitContainer3.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -755,8 +1124,7 @@
     private System.Windows.Forms.TabPage tpJobControl;
     private System.Windows.Forms.SplitContainer scJobControl;
-    private System.Windows.Forms.ListView lvJobControl;
     private System.Windows.Forms.CheckBox checkBox1;
     private System.Windows.Forms.ContextMenuStrip contextMenuJob;
-    private System.Windows.Forms.ToolStripMenuItem menuItemAbortJob;
+    private System.Windows.Forms.ToolStripMenuItem offlineItemAbortJob;
     private System.Windows.Forms.ToolStripMenuItem menuItemGetSnapshot;
     private System.Windows.Forms.ToolStripMenuItem viewToolStripMenuItem;
@@ -779,4 +1147,31 @@
     private System.Windows.Forms.ToolStripMenuItem projectToolStripMenuItem;
     private System.Windows.Forms.ToolStripMenuItem menuItemOpenCalendar;
+    private System.Windows.Forms.TabControl calculatingJobTabControl;
+    private System.Windows.Forms.TabPage finishedJobsTabPage;
+    private System.Windows.Forms.TabPage offlineJobsTabPage;
+    private System.Windows.Forms.TabPage calculatingJobTabPage;
+    private System.Windows.Forms.SplitContainer splitContainer2;
+    private System.Windows.Forms.Button btn_finishedJob_next;
+    private System.Windows.Forms.Button btn_finishedJob_prev;
+    private System.Windows.Forms.ComboBox cmb_finishedJob_count;
+    private System.Windows.Forms.ListView lv_finishedJobs;
+    private System.Windows.Forms.SplitContainer splitContainer3;
+    private System.Windows.Forms.ComboBox comboBox1;
+    private System.Windows.Forms.Button button1;
+    private System.Windows.Forms.Button button2;
+    private System.Windows.Forms.ListView listView1;
+    private System.Windows.Forms.SplitContainer splitContainer5;
+    private System.Windows.Forms.ComboBox cmb_calculatingJob_count;
+    private System.Windows.Forms.Button btn_calculatingJobs_next;
+    private System.Windows.Forms.Button btn_calculatingJobs_prev;
+    private System.Windows.Forms.ListView lv_calculatingJobs;
+    private System.Windows.Forms.SplitContainer splitContainer4;
+    private System.Windows.Forms.ComboBox cmb_offlineJob_count;
+    private System.Windows.Forms.Button btn_offlineJob_next;
+    private System.Windows.Forms.Button btn_offlinejob_prev;
+    private System.Windows.Forms.ListView lv_offlineJobs;
+    private System.Windows.Forms.ContextMenuStrip AbortContextMenuStrip;
+    private System.Windows.Forms.ToolStripMenuItem toolStripMenuItem1;
+    private System.Windows.Forms.ToolStripMenuItem calcToolStripAbortItem;
   }
 }